//FRS Control Program 
//VHF Version
//Module SR-FRS-1W
//RA4FHE Penza (c)2015



// добавляем необходимые библиотеки
#include <LiquidCrystal.h>

LiquidCrystal lcd(8, 9, 4, 5, 6, 7 );

// установка первоначальных параметров модуля SR-FRS-1W
int bw = 1;                               // Ширина полосы канала KHz ( 0= 12.5KHz или 1= 25KHz )
double tfv = 145.7000;                    // Частота передачи MHz (134.0000 - 174.0000)
double rfv = 145.7000;                    // Частота приёма MHz (134.0000 - 174.0000) 
String rxcxcss = "000";                   // Код RX 01-38： CTCSS （analog ） 39-121：CDCSS （digital ）
String txcxcss = "000";                   // Код TX 01-38： CTCSS （analog ） 39-121：CDCSS （digital ） 
int sql = 2;                              // Уровень шумодава (0-8); 
int vol = 1;                              // Громкость (1-9)
int flag = 1;                             // Мощьность
int mic = 8;                              // Чуствительность микрофона (1-8)
int scr = 0;                              // Скремблер (0-8)

// UDG
byte udg[8] = {
  B11111,
  B10001,
  B10001,
  B10001,
  B10001,
  B10001,
  B11111,
};

// кнопки
int button;
const int BUTTON_NONE   = 0;
const int BUTTON_RIGHT  = 1;
const int BUTTON_UP     = 2;
const int BUTTON_DOWN   = 3;
const int BUTTON_LEFT   = 4;
const int BUTTON_SELECT = 5;

int getPressedButton()
{
  int buttonValue = analogRead(0); // считываем значения с аналогового входа(A0) 
  if (buttonValue < 100) {
    return BUTTON_RIGHT;  
  }
  else if (buttonValue < 200) {
    return BUTTON_UP;
  }
  else if (buttonValue < 400){
    return BUTTON_DOWN;
  }
  else if (buttonValue < 600){
    return BUTTON_LEFT;
  }
  else if (buttonValue < 800){
    return BUTTON_SELECT;
  }
  return BUTTON_NONE;
}


void setup()
{
  Serial.begin(9600);                      // Открываем порт 9600 bps
  delay(10);
  Serial.print("AT+DMOSETGROUP=");         // AT+DMOSETGROUP (Group setting command)
  Serial.print(bw,1);
  Serial.print(",");
  Serial.print(tfv,4); 
  Serial.print(",");
  Serial.print(rfv,4);
  Serial.print(",");
  Serial.print(rxcxcss);
  Serial.print(",");
  Serial.print(sql);
  Serial.print(",");
  Serial.print(txcxcss);
  Serial.print(",");
  Serial.println(flag);

  Serial.print("AT+DMOSETVOLUME=");            // AT+DMOSETVOLUME (Volume setting command)
  Serial.println(vol,1);

  Serial.print("AT+DMOSETMIC=");            // AT+DMOSETMIC (Microphone sensitivity & Voice scram setting command)
  Serial.print(mic);
  Serial.print(",");
  Serial.println(scr);


  lcd.begin(16, 2);             
  lcd.print("   FRS  BOARD"); 
  lcd.setCursor(0, 1);
  lcd.print("(c)RA4FHE  Penza");   
  delay (3000);
  lcd.clear(); 
}

void loop()
{
  button = getPressedButton();
  switch (button)
  {
  case BUTTON_RIGHT: 
    tfv = tfv + 1.0000;
    rfv = rfv + 1.0000;
    delay (200);
    lcd.setCursor(0, 0); 
    lcd.print("                 "); 
    lcd.setCursor(0, 0);
    lcd.print(" Frq:");
    lcd.print(rfv, 3);
    lcd.print("MHz");
    Serial.print("AT+DMOSETGROUP=");         // AT+DMOSETGROUP=GBW,TFV,RFV,RXCXCSS,SQ,TXCXCSS,FLAG
    Serial.print(bw,1);
    Serial.print(",");
    Serial.print(tfv,4); 
    Serial.print(",");
    Serial.print(rfv,4);
    Serial.print(",");
    Serial.print(rxcxcss);
    Serial.print(",");
    Serial.print(sql);
    Serial.print(",");
    Serial.print(txcxcss);
    Serial.print(",");
    Serial.println(flag);
    break;
  case BUTTON_LEFT:
    tfv = tfv - 1.0000;    
    rfv = rfv - 1.0000;
    delay (200);
    lcd.setCursor(0, 0); 
    lcd.print("                   "); 
    lcd.setCursor(0, 0);
    lcd.print(" Frq:");
    lcd.print(rfv, 3);
    lcd.print("MHz");
    Serial.print("AT+DMOSETGROUP=");         // AT+DMOSETGROUP=GBW,TFV,RFV,RXCXCSS,SQ,TXCXCSS,FLAG
    Serial.print(bw,1);
    Serial.print(",");
    Serial.print(tfv,4); 
    Serial.print(",");
    Serial.print(rfv,4);
    Serial.print(",");
    Serial.print(rxcxcss);
    Serial.print(",");
    Serial.print(sql);
    Serial.print(",");
    Serial.print(txcxcss);
    Serial.print(",");
    Serial.println(flag);
    break;
  case BUTTON_UP:
    tfv = tfv + 0.0250;
    rfv = rfv + 0.0250;
    delay (200);
    lcd.setCursor(0, 0); 
    lcd.print("                  "); 
    lcd.setCursor(0, 0);
    lcd.print(" Frq:");
    lcd.print(rfv, 3);
    lcd.print("MHz");
    Serial.print("AT+DMOSETGROUP=");         // AT+DMOSETGROUP=GBW,TFV,RFV,RXCXCSS,SQ,TXCXCSS,FLAG
    Serial.print(bw,1);
    Serial.print(",");
    Serial.print(tfv,4); 
    Serial.print(",");
    Serial.print(rfv,4);
    Serial.print(",");
    Serial.print(rxcxcss);
    Serial.print(",");
    Serial.print(sql);
    Serial.print(",");
    Serial.print(txcxcss);
    Serial.print(",");
    Serial.println(flag);
    break;
  case BUTTON_DOWN:
    tfv = tfv - 0.0250;
    rfv = rfv - 0.0250;
    delay (200);
    lcd.setCursor(0, 0); 
    lcd.print("                "); 
    lcd.setCursor(0, 0);
    lcd.print(" Frq:");
    lcd.print(rfv, 3);
    lcd.print("MHz");
    Serial.print("AT+DMOSETGROUP=");         // AT+DMOSETGROUP=GBW,TFV,RFV,RXCXCSS,SQ,TXCXCSS,FLAG
    Serial.print(bw,1);
    Serial.print(",");
    Serial.print(tfv,4); 
    Serial.print(",");
    Serial.print(rfv,4);
    Serial.print(",");
    Serial.print(rxcxcss);
    Serial.print(",");
    Serial.print(sql);
    Serial.print(",");
    Serial.print(txcxcss);
    Serial.print(",");
    Serial.println(flag);
    break;
  case BUTTON_SELECT:
    vol = vol + 1;
    if (vol > 9)
    {
      vol = 1;
    }
    delay (200);
    lcd.createChar(0, udg);
    lcd.setCursor(1, 1);
    lcd.print("Vol:"); 
    lcd.setCursor(vol + 4, 1); 
    lcd.write(byte(0));
    if (vol == 9)
    { 
      lcd.setCursor(1, 1);
      lcd.print("Vol:");
      lcd.print("           ");
    }

    Serial.print("AT+DMOSETVOLUME=");            // AT+DMOSETVOLUME (Volume setting command)
    Serial.println(vol,1);
    break;
  }
}







